--Trainee Script 0.7 for Alice Beta 2 by SEKoner

--Press F1 = Godmode ON
--Press F2 = Add Armour
--Press F3 = Clear Wanted Level
--Press F4 = RepairCar
--Press F5 = Save Game
--Press F6 = Add Money 3754$
--Press F7 = Unlock Bridges
--Press F8 = Spawn Police Car
--Press F9 = Spawn Infernus
--Press F10 = Spawn Tourismo
--Press F11 = Spawn FBI Buffalo
--Press F12 = Spawn Annihilator
--Press ALT+F1 = = Godmode OFF
--Press ALT+F2 = = Toggle Water
--Press ALT+F3 = = Toggle Shadows


--globale variablen
 PLAYER_ID, PLAYER_INDEX, PLAYER_CHAR, PLAYER_CAR, SAVEDONE, TIMER = 0

function InitScript()
 -- Wake up neo ... wake up .... ;)
 Wait(10000)
end

function WaitForPlayerPoolCreation()
  while (IsPlayerPoolCreated() == 0) do
    Wait(2000)
  end
end

function WaitForValidPlayer()
  PLAYER_CHAR = 0
  repeat 
    CallNative("GET_PLAYER_ID")
	PLAYER_ID = GetIntResult()
	if (PLAYER_ID >= 0) then
	  PushInt(PLAYER_ID)
	  CallNative("CONVERT_INT_TO_PLAYERINDEX")
	  PLAYER_INDEX = GetIntResult()
	  PushInt(PLAYER_INDEX)
      PushVarPtr()	
	  CallNative("GET_PLAYER_CHAR")
	  PLAYER_CHAR = GetIntParam(1)
	  if (PLAYER_CHAR <= 0) then
	    Wait(1000)
	  end  
	end 
  until (PLAYER_CHAR > 0)  
end

function getPlayerCar()
 PLAYER_CAR = 0
 IN_CAR = 0
 repeat
   PushInt(PLAYER_CHAR)
   CallNative("IS_CHAR_IN_ANY_CAR")
   IN_CAR = GetIntResult()
   if(IN_CAR > 0) then
     PushInt(PLAYER_CHAR)
     PushVarPtr()
     CallNative("GET_CAR_CHAR_IS_USING")
     PLAYER_CAR = GetIntParam(1)
   end
   if (PLAYER_CAR <= 0) then
     Wait(1000)
   end
 until (PLAYER_CAR > 0)
end

function GetSpawnCoords()
  PushInt(PLAYER_CHAR)
  PushFloat(0.0)
  PushFloat(5.0)
  PushFloat(0.0)
  PushVarPtr()
  PushVarPtr()
  PushVarPtr()
  CallNative("GET_OFFSET_FROM_CHAR_IN_WORLD_COORDS")
  X = GetFloatParam(4)
  Y = GetFloatParam(5)
  Z = GetFloatParam(6) 
end

-- Text functions

function ShowHelpMsg(msg) 
  PushStr(msg)
  CallSpecNative("PRINT_HELP")
end

function SetTimerA(val)
PushInt(val)
CallSpecNative("SETTIMERA")
end

function GetTimerATick()
CallSpecNative("TIMERA")
return GetIntResult()
end 

function DisplayText(txt, x, y)
PushFloat(x)
PushFloat(y)
PushStr("STRING")
PushStr(txt)
CallSpecNative("DISPLAY_TEXT_WITH_LITERAL_STRING")
end 

function ShowText(msg)
 SetTimerA(0)
 repeat
  DisplayText(msg, 0.01, 0.01)
  Wait(20)
 until (GetTimerATick() > 1000)
end

-- Carspawn functions

function SpawnCar(name)
  PushStr(name)
  CallNative("GET_HASH_KEY")
  hash = GetIntResult()
  PushInt(hash)
  CallSpecNative("REQUEST_MODEL")
  Res = 0
  while Res == 0 do
    PushInt(hash)
    CallSpecNative("HAS_MODEL_LOADED")
    Res = GetIntResult()
  end
  GetSpawnCoords()
  PushInt(hash)
  PushFloat(X)
  PushFloat(Y)
  PushFloat(Z)
  PushVarPtr()
  PushInt(1)
  CallSpecNative("CREATE_CAR")
  CAR_HANDLE = GetIntParam(4)
  PushInt(hash)
  CallSpecNative("MARK_MODEL_AS_NO_LONGER_NEEDED")
  ShowHelpMsg(name) -- can shows not for all cars in this function because model name
  Wait(1000)        -- not always == gxt name
  PushVarNumPtr(1)
  SetIntParam(1, CAR_HANDLE)
  CallSpecNative("MARK_CAR_AS_NO_LONGER_NEEDED") 
  Wait(3000)
end

function repairCar(playerCar)
   PushInt(playerCar)
   CallNative("FIX_CAR")
  ShowText("Car repaired")
   SetHazardlights(playerCar)
   Wait(500)
   SetHazardlights1(playerCar)
   Wait(500)
   SetHazardlights(playerCar)
   Wait(500)
   SetHazardlights1(playerCar)
   Wait(500)
   SetHazardlights(playerCar)
   Wait(500)
   SetHazardlights1(playerCar)
   Wait(500)
   SetHazardlights(playerCar)
   Wait(500)
   SetHazardlights1(playerCar)
   Wait(300)
end

function SetHazardlights(carIndex)
 PushInt(carIndex)
 PushInt(1)
 CallNative("SET_VEH_INDICATORLIGHTS")
end

function SetHazardlights1(carIndex)
 PushInt(carIndex)
 PushInt(0)
 CallNative("SET_VEH_INDICATORLIGHTS")
end

-- Cheating Stuff

function SaveGame()
  SAVEDONE = 0
  TIMER = 0
  CallNative("ACTIVATE_SAVE_MENU")
  Wait(1000)
  while (SAVEDONE == 0) and (TIMER < 10000) do
    TIMER = TIMER + 100
	Wait(100)
	CallNative("DID_SAVE_COMPLETE_SUCCESSFULLY")
	SAVEDONE = GetIntResult()
  end
end

function MakeGod()
  DO1 = 1
  PushInt(PLAYER_CHAR)
  PushInt(200)
  CallNative("SET_CHAR_HEALTH")
  Wait(300)
  PushInt(PLAYER_INDEX)
  PushInt(DO1)
  CallNative("SET_PLAYER_INVINCIBLE")
  PushInt(PLAYER_INDEX)
  PushInt(DO1)
  CallNative("SET_PLAYER_NEVER_GETS_TIRED")
  PushInt(PLAYER_INDEX)
  PushInt(DO1)
  ShowText("Godmode enabled")
  Wait(300)
end

function EndGod()
  DO1 = 0
  PushInt(PLAYER_INDEX)
  PushInt(DO1)
  CallNative("SET_PLAYER_INVINCIBLE")
  PushInt(PLAYER_INDEX)
  PushInt(DO1)
  CallNative("SET_PLAYER_NEVER_GETS_TIRED")
  PushInt(PLAYER_INDEX)
  PushInt(DO1)
  Wait(300)
  ShowText("Godmode disabled")
end

function GiveArmour()
  PushInt(PLAYER_CHAR)
  PushInt(200)
  CallNative("ADD_ARMOUR_TO_CHAR")
  ShowText("Armour added")
  Wait(300)
end

function ClearWanted()
  PushInt(0)
  CallNative("CLEAR_WANTED_LEVEL")
  ShowText("Wanted-Level cleared")
  Wait(300)
end

function GiveMeMoney()
  PushInt(PLAYER_ID)
  PushInt(3754)
  CallNative("ADD_SCORE")
  ShowText("Money added")
  Wait(300)
end

function UnlockBridges()
  PushInt(363)
  PushInt(3)
  CallNative("SET_INT_STAT")
  ShowText("Bridges unlocked")
  Wait(300)
end

-- Graphical Stuff

function fancyWaterEnable()
  if waterMode == 0 then
    PushInt(0)
    CallNative("ENABLE_FANCY_WATER")
    waterMode = 1
    ShowText("Water invisible")
  else
    PushInt(1)
    CallNative("ENABLE_FANCY_WATER")
    waterMode = 0
    ShowText("Water visible")
  end
  Wait(300)
end

function shadowsEnable()
  if shadowMode == 0 then
    PushInt(1)
    CallNative("ENABLE_SHADOWS")
    shadowMode = 1
    ShowText("Shadows enabled")
  else
    PushInt(0)
    CallNative("ENABLE_SHADOWS")
    shadowMode = 0
    ShowText("Shadows disabled")
  end
end

-- Main Functions

function main()
 InitScript()
 while true do
   WaitForPlayerPoolCreation()
   WaitForValidPlayer()
-- F1 ----------------------------- 
   if (IsKeyPressed(112) == 1) then
      if (IsKeyPressed(18) == 1) then
         EndGod()
      else
         MakeGod()
      end
   end
-- F2 ----------------------------- 
   if (IsKeyPressed(113) == 1) then
      if (IsKeyPressed(18) == 1) then
	 fancyWaterEnable()
      else
         GiveArmour()
      end
   end
-- F3 ----------------------------- 
   if (IsKeyPressed(114) == 1) then
      if (IsKeyPressed(18) == 1) then
	 shadowsEnable()
      else
         ClearWanted()
      end
   end
-- F4 ----------------------------- 
   if (IsKeyPressed(115) == 1) then
     getPlayerCar()
     if PLAYER_CAR > 0 then
       repairCar(PLAYER_CAR)
     end
   end
-- F5 ----------------------------- 
   if (IsKeyPressed(116) == 1) then
      SaveGame()
   end
-- F6 ----------------------------- 
   if (IsKeyPressed(117) == 1) then
      GiveMeMoney()
   end
-- F7 ----------------------------- 
   if (IsKeyPressed(118) == 1) then
      UnlockBridges()
   end
-- F8 ----------------------------- 
   if (IsKeyPressed(119) == 1) then
      SpawnCar("police2")
   end
-- F9 ----------------------------- 
   if (IsKeyPressed(120) == 1) then
      SpawnCar("infernus")
   end
-- F10 ---------------------------- 
   if (IsKeyPressed(121) == 1) then
      SpawnCar("turismo")
   end
-- F11 ---------------------------- 
   if (IsKeyPressed(122) == 1) then
      SpawnCar("fbi")
   end
-- F12 ---------------------------- 
   if (IsKeyPressed(123) == 1) then
      SpawnCar("annihilator")
   end
   Wait(1700)
 end
end

main();